#ifndef MAP
#define MAP
#include "includes.h"

extern Sound soundManager;

class Map
{
public:

	std::string name = "";
	std::string filename = "";
	int playerPositionDefault[2];
	int* boxPositionDefault[2];
	int playerPosition[2];
	int* boxPosition[2];
	int* targetPosition[2];
	int width = 0;
	int height = 0;
	int param = 0;
	char** map;
	int boxCount = 0, targetCount = 0;
	int playerSpriteMovement = 0;
	int* boxSpriteMovement;
	int* boxSpriteMovementDirection;
	bool* isDrowned;
	int playerRotation = 0; // 0 - gora // 1 - prawo // 2 - dol // 3 - lewo //
	bool end = false;
	bool drowned = false;
	int finishedBoxes = 0;
	int difficulty, difficultylevel;
	int movesCount = 0;
	int timeLimit = 0;
	bool splashed = false;

	Map();
	~Map();
	int CalculateScore();
	void Reset();
	void InitMapSize();
	bool CheckIfFinished();
	void RewriteMapSize(int oldx, int oldy); //wykonywane PO zmianie wartoci zmiennych height, width
	int MoveHere(int x, int y, char direction, int type = -1, bool isWaterDeadly = false); // -1 - player // 0-... - block //
};

#endif